/** Implements Dog
 *  @author Josh Hug
 */

public class Dog {
	private String name;
	private static String breed; /* static, so cannot change after creation */
	private double size;  /* weight. in the imperial system. sorry */

	/** shared by all isntances and the class itself.
	   public static non-final variables are a bad idea  */
	public static String binomen = "Canis familiaris";

	/** returns string representation of dog */
	public String toString() {
		return name + " is a " + breed + " weighing " + size + " standard lb units.";
	}

	/** accessor method for size */
	public double getSize() {
		return size;
	}

	/** returns max of two dogs D1 and D2 */
	/* Even though size field is public, this method is part
	   of the Dog class, so things will be fine */
	public static Dog maxDog(Dog d1, Dog d2) {
		if (d1.size >= d2.size)
			return d1;
		return d2;
	}

	/** bark */
	public void bark() {
		System.out.println(name + " says: bark. bark.... bark.");
	}

	/** constructor */
	public Dog(String n, String b, double s) {
		name = n;
		breed = b;
		if (s < 0) {
			// could have been org.junit.Assert.assertTrue(s > 0);
			// but see not below
			throw new IllegalArgumentException(
				      "Dog is too small for this universe.");
		}

	 	// don't actually use JUnit asserts like the above in *real* code
	 	//
	 	// assertions should udaelly only be used for things that
	 	// indicate a fundamental problem with the code, as opposed
	 	// to things like malformed parameters
	 	//
	 	// 
		// Use exceptions instead. We'll learn how exceptions
		// work later. In the meantime, feel free to use
		// Junit tests like this

		size = s;
	}
}

